# Contributing

Thank you for your interest in contributing to Grafonnet! We welcome all people
who want to contribute in a healthy and constructive manner within our
community. Grafonnet is developed within the Grafana community. Therefore we
are following the same [Code of Conduct as
Grafana](https://github.com/grafana/grafana/blob/master/CODE_OF_CONDUCT.md). To
help us create a safe and positive community experience for all, we require all
participants to adhere to it.

## Version Support

We strive to only support the latest and last major Grafana versions - currently
6 and 7.

## Feature Support

**Grafonnet only aims to support core features and plugins.**

In terms of plugins, this means only those that are pre-installed:

* Alert List
* Azure Monitor
* Bar gauge
* CloudWatch
* Dashboard list
* Elasticsearch
* Gauge
* Graph
* Graphite
* Heatmap
* InfluxDB
* Jaeger
* Logs
* Loki
* Microsoft SQL Server
* MySQL
* News
* OpenTSDB
* Plugin list
* PostgreSQL
* Prometheus
* Singlestat
* Stackdriver
* Stat
* Table
* Table (old)
* TestData DB
* Text
* Zipkin

While Grafonnet itself only supports core Grafana functionality, we strongly
encourage development and use of community Grafonnet extensions. See the
[Community Plugins](https://grafana.github.io/grafonnet-lib/community-plugins/)
page for more info on this.
